/**
 * GSweeper applet
 *
 * @author Manuke
 */

package gsweeper;

// import

import java.awt.*;
import java.net.*;
import java.util.*;

import javax.swing.*;

// class implementation

public class GSApplet
	extends JApplet
{
	// create & destroy

	@Override
	public void init() {
		GSParameters params = new GSParameters();
		if (!params.loadResource()) {
			initParameters(params);
		}
		Container contentPane = getContentPane();
		GSMainPanel mainPanel = new GSMainPanel(params);
		contentPane.add(mainPanel);
		mainPanel.setVisible(true);
	}

	protected void initParameters(
		GSParameters params)
	{
		ArrayList<String[]> opts = new ArrayList<String[]>();
		for (String[] parameter : GSParameters.PARAMETER_INFO) {
			String paramName = parameter[0],
				paramValue = getParameter(paramName);
			if (paramValue != null) {
				opts.add(new String[] { "--"+paramName, paramValue });
			}
		}
		params.uriProcessor = new GSURIProcessor() {
			// uri

			@Override
			public URI createURI(String uriStr){
				if ((uriStr == null) || (uriStr.length() <= 0)) {
					return null;
				}
				URI uri;
				try {
					uri = new URL(getCodeBase(), uriStr).toURI();
				} catch (Exception e) {
					uri = null;
				}
				return uri;
			}

			@Override
			public void browseURI(URI uri) {
				try {
					getAppletContext().showDocument(uri.toURL());
				} catch (Exception e) {
				}
			}
		};
		params.decode(opts, null);
	}

	// information

	@Override
	public String getAppletInfo() {
		return GSParameters.APP_INFO;
	}

	@Override
	public String[][] getParameterInfo() {
		return GSParameters.PARAMETER_INFO;
	}
}
