/**
 * GSweeper digit image manager
 *
 * @author Manuke
 */

package gsweeper;

// import

import java.awt.*;
import java.awt.image.*;

// class implementation

class GSDigitManager {
	// constant

	private static final String DIGITS_NAME =
		"image/digits.png";

	// attribute

	BufferedImage allDigitsImage_;
	BufferedImage[] digitImages_ = new BufferedImage[10];
	Dimension digitDim_ = new Dimension(1, 1);

	// create & destroy

	public GSDigitManager() {
		allDigitsImage_ = GSImageUtility.loadResourceImage(
			DIGITS_NAME);
		if (allDigitsImage_ != null) {
			digitDim_.width = allDigitsImage_.getWidth()/5;
			digitDim_.height = allDigitsImage_.getHeight()/2;
			for (int digit = 0; digit < 10; digit++) {
				int x = (digit%5)*digitDim_.width,
					y = (digit/5)*digitDim_.height;
				digitImages_[digit] = allDigitsImage_.getSubimage(
					x, y, digitDim_.width, digitDim_.height);
			}
		}
	}

	// property

	public BufferedImage getAllDigitsImage() {
		return allDigitsImage_;
	}

	public BufferedImage getDigitImage(int digit) {
		return ((digit >= 0) && (digit <= 9))?
			digitImages_[digit]:
			null;
	}

	public Dimension getDigitDim() {
		return new Dimension(digitDim_);
	}

	// utility

	public static int adjustCols(int cols, int maxValue) {
		String maxStr = String.valueOf(maxValue);
		if (maxStr.length() > cols) {
			cols = maxStr.length();
		}
		return cols;
	}
}
