/**
 * GSweeper icon image manager
 *
 * @author Manuke
 */

package gsweeper;

// import

import java.awt.*;
import java.awt.image.*;

// class implementation

class GSIconManager {
	// constant

	public static final int CX_ICONBORDER = 2;
	public static final int CY_ICONBORDER = 2;

	public static final int ICON_QUESTION = 0;
	public static final int ICON_NUM1 = 1;
	public static final int ICON_NUM2 = 2;
	public static final int ICON_NUM3 = 3;
	public static final int ICON_NUM4 = 4;
	public static final int ICON_NUM5 = 5;
	public static final int ICON_NUM6 = 6;
	public static final int ICON_NUM7 = 7;
	public static final int ICON_NUM8 = 8;
	public static final int ICON_TALISMAN = 9;
	public static final int ICON_BADTALISMAN = 10;
	public static final int ICON_GHOST = 11;
	public static final int ICON_EXGHOST = 12;
	public static final int ICON_COUNT = 13;

	private static final String[] ICON_NAMES = {
		"image/icon_question.png",
		"image/icon_num1.png",
		"image/icon_num2.png",
		"image/icon_num3.png",
		"image/icon_num4.png",
		"image/icon_num5.png",
		"image/icon_num6.png",
		"image/icon_num7.png",
		"image/icon_num8.png",
		"image/icon_talisman.png",
		"image/icon_badtalisman.png",
		"image/icon_ghost.png",
		"image/icon_exghost.png"
	};

	// attribute

	BufferedImage[] icons_ = new BufferedImage[ICON_COUNT];

	// create & destroy

	public GSIconManager(
		int cols, int rows,
		Dimension pictureDim)
	{
		Dimension cellDim = new Dimension(
			pictureDim.width/cols,
			pictureDim.height/rows);
		Dimension iconDim = new Dimension(
			cellDim.width-CX_ICONBORDER*2,
			cellDim.height-CY_ICONBORDER*2);
		if (iconDim.width < 1) {
			iconDim.width = 1;
		}
		if (iconDim.height < 1) {
			iconDim.height = 1;
		}
		if (iconDim.width >= iconDim.height) {
			iconDim.width = iconDim.height;
		} else {
			iconDim.height = iconDim.width;
		}
		for (int i = 0; i < ICON_COUNT; i++) {
			icons_[i] =
				GSImageUtility.getFittedImage(
					GSImageUtility.loadResourceImage(ICON_NAMES[i]),
					iconDim,
					true, true);
		}
	}

	// property

	public BufferedImage getIcon(int n) {
		return ((n >= 0) && (n < ICON_COUNT))?
			icons_[n]:
			null;
	}
}
