/**
 * GSweeper image view component
 *
 * @author Manuke
 */

package gsweeper;

// import

import java.awt.*;
import java.awt.image.*;

// class implementation

class GSImageView
	extends GSComponent
{
	// attribute

	BufferedImage image_ = null;

	// create & destroy

	public GSImageView() {
	}

	public GSImageView(BufferedImage image) {
		image_ = image;
		shrink();
	}

	// property

	public BufferedImage getImage() {
		return image_;
	}

	public void setImage(BufferedImage image) {
		image_ = image;
		repaint();
	}

	// operation

	public void shrink(int borderWidth, int borderHeight) {
		if (image_ != null) {
			Dimension viewDim = new Dimension(
				image_.getWidth()+borderWidth*2,
				image_.getHeight()+borderHeight*2);
			setAllSize(viewDim);
		}
	}

	public void shrink() {
		shrink(0, 0);
	}

	// draw

	@Override
	public void paintComponent(Graphics g) {
		if (image_ != null) {
			Dimension viewDim = getSize(null),
				imageDim = new Dimension(
					image_.getWidth(), image_.getHeight());
			g.drawImage(
				image_,
				(viewDim.width-imageDim.width)/2,
				(viewDim.height-imageDim.height)/2,
				null);
		}
	}
}
