/**
 * GSweeper logo panel
 *
 * @author Manuke
 */

package gsweeper;

import java.awt.*;
import java.awt.image.*;

// import

// class implementation

class GSLogoPanel
	extends GSPanel
{
	// constant

	// constant

	public static final int CX_SPACE = 20;
	public static final int CY_SPACE = 20;

	public static final String LOGO_NAME =
		"image/logo.png";

	// attribute
	GSImageView logoView_;

	// create & destroy

	public GSLogoPanel(GSGame game) {
		Dimension pictureDim = game.getPictureDim(),
		maxDim = new Dimension(
			pictureDim.width-CX_SPACE*2,
			pictureDim.width-CX_SPACE*2);
		setAllSize(pictureDim);
		setLayout(null);
		logoView_ = new GSImageView();
		BufferedImage logoImage =
			GSImageUtility.getHalfImage(
				GSImageUtility.loadResourceImage(LOGO_NAME),
				maxDim);
		if (logoImage != null) {
			logoView_.setImage(logoImage);
			logoView_.shrink();
			logoView_.setBounds(
				pictureDim.width-logoImage.getWidth()-CX_SPACE,
				pictureDim.height-logoImage.getHeight()-CY_SPACE,
				logoImage.getWidth(),
				logoImage.getHeight());
		}
		add(logoView_);
		logoView_.setVisible(true);
	}
}
