/**
 * GSweeper picture view panel
 *
 * @author Manuke
 */

package gsweeper;

// import

import java.awt.*;
import java.awt.image.*;

// class implementation

class GSPictureView
	extends GSClickablePanel
{
	// attribute

	Object sync_ = new Object();
	GSGame game_;
	GSPictureManager pictman_;

	// create & destroy

	public GSPictureView(
		GSGame game,
		GSPictureManager pictman)
	{
		super(true);
		setOpaque(true);
		game_ = game;
		pictman_ = pictman;
		Dimension pictureDim = pictman_.getPictureDim();
		setAllSize(pictureDim);
		game_.addStatusListener(new GSGame.StatusListener() {
			// status listener

			@Override
			public void modeChanged(GSGame.StatusEvent e) {
			}

			@Override
			public void opensChanged(GSGame.StatusEvent e) {
				if (isVisible()) {
					repaint();
				}
			}

			@Override
			public void talismansChanged(GSGame.StatusEvent e) {
			}
		});
		pictman_.addLoadingListener(new GSPictureManager.LoadingListener() {
			// loading listener

			@Override
			public void loadingUpdated(GSPictureManager.LoadingEvent e) {
				if (e.completed && isVisible()) {
					repaint();
				}
			}
		});
	}

	// paint

	@Override
	public void paintComponent(Graphics g) {
		BufferedImage compositePicture =
			pictman_.buildCompositePicture(game_);
		if (compositePicture != null) {
			g.drawImage(compositePicture, 0, 0, null);
		}
	}
}
