/**
 * GSweeper main module
 *
 * @author Manuke
 */

package gsweeper;

import java.awt.*;
import java.io.*;
import java.net.*;

// class implementation

public class GSweeper {
	// main

	public static void main(String[] args) {
		GSParameters params = new GSParameters();
		if (!params.loadResource()) {
			initParameters(params, args);
		}
		if (params.help) {
			for (String helpLine : GSParameters.HELP_MESSAGE) {
				System.out.println(helpLine);
			}
			return;
		}
		GSFrame GSFrame = new GSFrame(params);
		GSFrame.setVisible(true);
	}

	protected static void initParameters(
		GSParameters params,
		String[] args)
	{
		params.uriProcessor = new GSURIProcessor() {
			// uri

			public URI createURI(String uriStr) {
				if ((uriStr == null) || (uriStr.length() <= 0)) {
					return null;
				}
				URI uri = null;
				try {
					uri = new URI(uriStr);
				} catch (Exception e) {
				}
				if (uri == null) {
					try {
						uri = new File(uriStr).toURI();
					} catch (Exception e) {
					}
				}
				return uri;
			}

			public void browseURI(URI uri) {
				try {
					Desktop.getDesktop().browse(uri);
				} catch (Exception e) {
				}
			}
		};
		params.decode(args);
	}
}
